      SUBROUTINE QSR2R(RINT,A,B,F,E,IERR)
         INTEGER IERR
         REAL A,B,E,F,RINT
         EXTERNAL UTQS11
         INTEGER I,J,M,N
         REAL D,H,S,T
         DIMENSION T(21)
       IERR = 0
       D = B - A
       T(1) = (F(A) + F(B))/2.
       N = 1
   10  CONTINUE
       DO 70 I = 1, 20
          S = 0.
          N = 2*N
          H = D/N
          DO 20 J = 1, N, 2
             S = S + F(A+J*H)
   20     CONTINUE
          T(I+1) = (2.*S/N + T(I))/2.
          M = 1
          J = I
   30     CONTINUE
          M = 4*M
          T(J) = T(J+1) + (T(J+1) - T(J))/(M - 1)
          J = J - 1
          IF (J - 1) 40, 30, 30
   40     CONTINUE
          IF (I - 3) 60, 50, 50
   50     CONTINUE
          IF (ABS(T(1) - T(2)) - E) 90, 90, 60
   60     CONTINUE
          IF (I .GE. 20) GO TO 80
   70     CONTINUE
   80  CONTINUE
       IERR = 65
       CALL UTQS11(IERR,12)
       GO TO 100
   90  CONTINUE
       RINT = T(1)*D
  100  RETURN
      END
